/*
 *  OSXDefaultFileLocation.h
 *  blast6 Prepared
 *
 *      This function sets the default file location,
 *  to which all fstream and other file operations are
 *  relative, to <yourapp>.app/Contents/Resources
 *
 *  This function was obtained from apple's awesome
 *  mac game development mailing list, and is public domain.
 *
 */
 
#ifndef OSXDEFAULTFILELOCATION_H
#define OSXDEFAULTFILELOCATION_H

#include <CoreServices/CoreServices.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void SetPathToResourcesFolder();
inline void SetPathToResourcesFolder()
{
	CFBundleRef mainBundle;
	char path[256];
	CFURLRef fileURL;
	CFStringRef s;
	
	mainBundle=CFBundleGetMainBundle();
	if(!mainBundle)
	{       printf("can't find main Bundle.\n");
			return;
	}
	
	//CFURLRef mainBundleURL=CFBundleCopyBundleURL(mainBundle);
	fileURL = CFBundleCopyBundleURL(mainBundle);
	if(!fileURL)
	{
		printf("can't find fileURL\n");
		return;
	}
	
	s = CFURLCopyFileSystemPath(fileURL, kCFURLPOSIXPathStyle);
	if(!s)
	{
		printf("Can't copy file system path.\n");
		return;
	}
	
	CFStringGetCString(s, path, sizeof(path), kCFStringEncodingASCII);
	strcat(path, "/Contents/Resources");
	CFRelease(fileURL);
	CFRelease(s);
	//printf("%s\n", path);
	chdir(path);
}

#endif